#include "F1.h"
#include "F2.h"

void someFunction() {
  std::cout << "global someFunction\n";
}

void foo();

namespace CS32 {
  namespace F1 {
    void anotherFn() {
      std::cout << "in another file\n";
    }
  }
}

struct S {
  int x;
  char c;
  double not_pi;
};

template<typename T, typename U>
size_t offset(T * base, U * field) {
  return reinterpret_cast<size_t>(field) - reinterpret_cast<size_t>(base);
}

struct T {
  //virtual bool contains(Point3D point);
  // ...
};

using namespace CS32::F1;

int main() {
  S bar;

  T baz[2];
  T * quux = new T[2];
  

  std::cout << sizeof(quux) << std::endl;
  std::cout << sizeof(baz) << std::endl;
  std::cout << sizeof(baz[0]) << std::endl;
  std::cout << sizeof(int *) << std::endl;
  std::cout << sizeof(void *) << std::endl;
  std::cout << &baz[0] << std::endl;
  std::cout << &baz[1] << std::endl;
  
  std::cout << sizeof(bar.x) << std::endl;
  std::cout << sizeof(bar.c) << std::endl;
  std::cout << sizeof(bar.not_pi) << std::endl;
  std::cout << sizeof(bar) << std::endl;

  std::cout << offset(&bar, &bar) << std::endl;
  std::cout << offset(&bar, &bar.x) << std::endl;
  std::cout << offset(&bar, &bar.c) << std::endl;
  std::cout << offset(&bar, &bar.not_pi) << std::endl;

  return 0;
  
  ::someFunction(); 
  foo();
  anotherFn();
  std::cout << "pi: " << PI << "\n";

  CS32::F1::someFunction();
  return 0;
}

void foo() {
  ::someFunction();
}
